Subject: Re: On Tabs and Spaces

From: Andreas Ericsson <[email-masked]>
Date: Thu, 18 Oct 2007 00:36:32 +0200

Jari Aalto wrote:
> * Wed 2007-10-17 Michael Witten <[email-masked]>
> * Message-Id: [email-masked]
>> On 17 Oct 2007, at 3:17:08 AM, Luke Lu wrote:
>>
>>> But I still haven't seen any compelling arguments against the "all
>>> space" case
>> Overhead!
>>
>> If you use 8 spaces instead of one tab,
>> that's using up 7x more space!
> 
> Software is the right place to worry about optimization. We should trust
> SCM to make proper and efficient deltas. If not, algorithms need
> improvemnts.
> 
> Any cross platform development or electronic exchange is guaranteed to
> be interpreted correctly when policy enforces "only spaces"
> 
> As we have already seen in numerous times in this thread, using tabs
> will - eventually - be interpreted in some editor, in some display, in
> some encironment using some tools ... incorrectly or different than the
> author intended. Simply because editors are configurable and we cannot
> know what settings they may have when they load the file in.
> 

And simply because nearly all (unix) editors still insert a hard tab
when pressing the tab key, and *mixing* tabs and spaces makes the
situation *really* unbearable, one really shouldn't use all spaces.

It's code, not graphics. If it's really horrible, any editor can be
configured to change the non-default tab-setting back to 8 if that's
the problem. Mine's set to 4. Primarily because I think 8 is too
much. Sometimes (roughly once every 2 years), that gives me problem.
It's exclusively when someone has consciously mixed tabs and spaces.
Using either or *never* gives any problem.

> There is no such problem with spaces. 
> 

I beg to differ, for reasons stated multiple times elsewhere in this
thread.

> The storage constraints are insignificant given the disk space vs. cost;

Perhaps, but it's low-hanging fruit and since all spaces have its issues
too, why not just go with tabs?

-- 
Andreas Ericsson                   [email-masked]
OP5 AB                             www.op5.se
Tel: +46 8-230225                  Fax: +46 8-230231